<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountCredit ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAccountCredit
 * @subpackage Arrays
 */
class ArrayOfAccountCredit extends AbstractStructArrayBase
{
    /**
     * The AccountCredit
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AccountCredit[]
     */
    public $AccountCredit;
    /**
     * Constructor method for ArrayOfAccountCredit
     * @uses ArrayOfAccountCredit::setAccountCredit()
     * @param \StructType\AccountCredit[] $accountCredit
     */
    public function __construct(array $accountCredit = array())
    {
        $this
            ->setAccountCredit($accountCredit);
    }
    /**
     * Get AccountCredit value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AccountCredit[]|null
     */
    public function getAccountCredit()
    {
        return isset($this->AccountCredit) ? $this->AccountCredit : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountCredit method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountCredit method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountCreditForArrayConstraintsFromSetAccountCredit(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountCreditAccountCreditItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountCreditAccountCreditItem instanceof \StructType\AccountCredit) {
                $invalidValues[] = is_object($arrayOfAccountCreditAccountCreditItem) ? get_class($arrayOfAccountCreditAccountCreditItem) : sprintf('%s(%s)', gettype($arrayOfAccountCreditAccountCreditItem), var_export($arrayOfAccountCreditAccountCreditItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountCredit property can only contain items of type \StructType\AccountCredit, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountCredit value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AccountCredit[] $accountCredit
     * @return \ArrayType\ArrayOfAccountCredit
     */
    public function setAccountCredit(array $accountCredit = array())
    {
        // validation for constraint: array
        if ('' !== ($accountCreditArrayErrorMessage = self::validateAccountCreditForArrayConstraintsFromSetAccountCredit($accountCredit))) {
            throw new \InvalidArgumentException($accountCreditArrayErrorMessage, __LINE__);
        }
        if (is_null($accountCredit) || (is_array($accountCredit) && empty($accountCredit))) {
            unset($this->AccountCredit);
        } else {
            $this->AccountCredit = $accountCredit;
        }
        return $this;
    }
    /**
     * Add item to AccountCredit value
     * @throws \InvalidArgumentException
     * @param \StructType\AccountCredit $item
     * @return \ArrayType\ArrayOfAccountCredit
     */
    public function addToAccountCredit(\StructType\AccountCredit $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AccountCredit) {
            throw new \InvalidArgumentException(sprintf('The AccountCredit property can only contain items of type \StructType\AccountCredit, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountCredit[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AccountCredit|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AccountCredit|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AccountCredit|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AccountCredit|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AccountCredit|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountCredit
     */
    public function getAttributeName()
    {
        return 'AccountCredit';
    }
}
