<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFindAccountTransactionItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFindAccountTransactionItem
 * @subpackage Arrays
 */
class ArrayOfFindAccountTransactionItem extends AbstractStructArrayBase
{
    /**
     * The FindAccountTransactionItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\FindAccountTransactionItem[]
     */
    public $FindAccountTransactionItem;
    /**
     * Constructor method for ArrayOfFindAccountTransactionItem
     * @uses ArrayOfFindAccountTransactionItem::setFindAccountTransactionItem()
     * @param \StructType\FindAccountTransactionItem[] $findAccountTransactionItem
     */
    public function __construct(array $findAccountTransactionItem = array())
    {
        $this
            ->setFindAccountTransactionItem($findAccountTransactionItem);
    }
    /**
     * Get FindAccountTransactionItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\FindAccountTransactionItem[]|null
     */
    public function getFindAccountTransactionItem()
    {
        return isset($this->FindAccountTransactionItem) ? $this->FindAccountTransactionItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFindAccountTransactionItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFindAccountTransactionItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFindAccountTransactionItemForArrayConstraintsFromSetFindAccountTransactionItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFindAccountTransactionItemFindAccountTransactionItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfFindAccountTransactionItemFindAccountTransactionItemItem instanceof \StructType\FindAccountTransactionItem) {
                $invalidValues[] = is_object($arrayOfFindAccountTransactionItemFindAccountTransactionItemItem) ? get_class($arrayOfFindAccountTransactionItemFindAccountTransactionItemItem) : sprintf('%s(%s)', gettype($arrayOfFindAccountTransactionItemFindAccountTransactionItemItem), var_export($arrayOfFindAccountTransactionItemFindAccountTransactionItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FindAccountTransactionItem property can only contain items of type \StructType\FindAccountTransactionItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FindAccountTransactionItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\FindAccountTransactionItem[] $findAccountTransactionItem
     * @return \ArrayType\ArrayOfFindAccountTransactionItem
     */
    public function setFindAccountTransactionItem(array $findAccountTransactionItem = array())
    {
        // validation for constraint: array
        if ('' !== ($findAccountTransactionItemArrayErrorMessage = self::validateFindAccountTransactionItemForArrayConstraintsFromSetFindAccountTransactionItem($findAccountTransactionItem))) {
            throw new \InvalidArgumentException($findAccountTransactionItemArrayErrorMessage, __LINE__);
        }
        if (is_null($findAccountTransactionItem) || (is_array($findAccountTransactionItem) && empty($findAccountTransactionItem))) {
            unset($this->FindAccountTransactionItem);
        } else {
            $this->FindAccountTransactionItem = $findAccountTransactionItem;
        }
        return $this;
    }
    /**
     * Add item to FindAccountTransactionItem value
     * @throws \InvalidArgumentException
     * @param \StructType\FindAccountTransactionItem $item
     * @return \ArrayType\ArrayOfFindAccountTransactionItem
     */
    public function addToFindAccountTransactionItem(\StructType\FindAccountTransactionItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FindAccountTransactionItem) {
            throw new \InvalidArgumentException(sprintf('The FindAccountTransactionItem property can only contain items of type \StructType\FindAccountTransactionItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FindAccountTransactionItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\FindAccountTransactionItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\FindAccountTransactionItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\FindAccountTransactionItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\FindAccountTransactionItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\FindAccountTransactionItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FindAccountTransactionItem
     */
    public function getAttributeName()
    {
        return 'FindAccountTransactionItem';
    }
}
