<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVoucherTransaction ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfVoucherTransaction
 * @subpackage Arrays
 */
class ArrayOfVoucherTransaction extends AbstractStructArrayBase
{
    /**
     * The VoucherTransaction
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VoucherTransaction[]
     */
    public $VoucherTransaction;
    /**
     * Constructor method for ArrayOfVoucherTransaction
     * @uses ArrayOfVoucherTransaction::setVoucherTransaction()
     * @param \StructType\VoucherTransaction[] $voucherTransaction
     */
    public function __construct(array $voucherTransaction = array())
    {
        $this
            ->setVoucherTransaction($voucherTransaction);
    }
    /**
     * Get VoucherTransaction value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VoucherTransaction[]|null
     */
    public function getVoucherTransaction()
    {
        return isset($this->VoucherTransaction) ? $this->VoucherTransaction : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVoucherTransaction method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVoucherTransaction method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVoucherTransactionForArrayConstraintsFromSetVoucherTransaction(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVoucherTransactionVoucherTransactionItem) {
            // validation for constraint: itemType
            if (!$arrayOfVoucherTransactionVoucherTransactionItem instanceof \StructType\VoucherTransaction) {
                $invalidValues[] = is_object($arrayOfVoucherTransactionVoucherTransactionItem) ? get_class($arrayOfVoucherTransactionVoucherTransactionItem) : sprintf('%s(%s)', gettype($arrayOfVoucherTransactionVoucherTransactionItem), var_export($arrayOfVoucherTransactionVoucherTransactionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VoucherTransaction property can only contain items of type \StructType\VoucherTransaction, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VoucherTransaction value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VoucherTransaction[] $voucherTransaction
     * @return \ArrayType\ArrayOfVoucherTransaction
     */
    public function setVoucherTransaction(array $voucherTransaction = array())
    {
        // validation for constraint: array
        if ('' !== ($voucherTransactionArrayErrorMessage = self::validateVoucherTransactionForArrayConstraintsFromSetVoucherTransaction($voucherTransaction))) {
            throw new \InvalidArgumentException($voucherTransactionArrayErrorMessage, __LINE__);
        }
        if (is_null($voucherTransaction) || (is_array($voucherTransaction) && empty($voucherTransaction))) {
            unset($this->VoucherTransaction);
        } else {
            $this->VoucherTransaction = $voucherTransaction;
        }
        return $this;
    }
    /**
     * Add item to VoucherTransaction value
     * @throws \InvalidArgumentException
     * @param \StructType\VoucherTransaction $item
     * @return \ArrayType\ArrayOfVoucherTransaction
     */
    public function addToVoucherTransaction(\StructType\VoucherTransaction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VoucherTransaction) {
            throw new \InvalidArgumentException(sprintf('The VoucherTransaction property can only contain items of type \StructType\VoucherTransaction, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VoucherTransaction[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VoucherTransaction|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VoucherTransaction|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VoucherTransaction|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VoucherTransaction|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VoucherTransaction|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VoucherTransaction
     */
    public function getAttributeName()
    {
        return 'VoucherTransaction';
    }
}
