<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'CommitAccountRequest' => '\\StructType\\CommitAccountRequest',
            'CommitAccountResponse' => '\\StructType\\CommitAccountResponse',
            'FindAccountTransactionRequest' => '\\StructType\\FindAccountTransactionRequest',
            'FindAccountTransactionResponse' => '\\StructType\\FindAccountTransactionResponse',
            'GetAccountRequest' => '\\StructType\\GetAccountRequest',
            'GetAccountResponse' => '\\StructType\\GetAccountResponse',
            'GetAccountByReferenceRequest' => '\\StructType\\GetAccountByReferenceRequest',
            'GetAccountByReferenceResponse' => '\\StructType\\GetAccountByReferenceResponse',
            'GetAvailableCreditByReferenceRequest' => '\\StructType\\GetAvailableCreditByReferenceRequest',
            'GetAvailableCreditByReferenceResponse' => '\\StructType\\GetAvailableCreditByReferenceResponse',
            'CommitAccountTransactionsRequest' => '\\StructType\\CommitAccountTransactionsRequest',
            'CommitAccountTransactionsResponse' => '\\StructType\\CommitAccountTransactionsResponse',
            'CommitAccountBatchRequest' => '\\StructType\\CommitAccountBatchRequest',
            'CommitAccountBatchResponse' => '\\StructType\\CommitAccountBatchResponse',
            'CommitAccountTransactionsBatchRequest' => '\\StructType\\CommitAccountTransactionsBatchRequest',
            'CommitAccountTransactionsBatchResponse' => '\\StructType\\CommitAccountTransactionsBatchResponse',
            'Account' => '\\StructType\\Account',
            'ArrayOfAccountCredit' => '\\ArrayType\\ArrayOfAccountCredit',
            'AccountCredit' => '\\StructType\\AccountCredit',
            'ArrayOfAccountTransaction' => '\\ArrayType\\ArrayOfAccountTransaction',
            'AccountTransaction' => '\\StructType\\AccountTransaction',
            'FindAccountTransactionRequestData' => '\\StructType\\FindAccountTransactionRequestData',
            'FindAccountTransactionResponseData' => '\\StructType\\FindAccountTransactionResponseData',
            'ArrayOfFindAccountTransactionItem' => '\\ArrayType\\ArrayOfFindAccountTransactionItem',
            'FindAccountTransactionItem' => '\\StructType\\FindAccountTransactionItem',
            'GetAccountRequestData' => '\\StructType\\GetAccountRequestData',
            'GetAccountByReferenceRequestData' => '\\StructType\\GetAccountByReferenceRequestData',
            'GetAvailableCreditByReferenceRequestData' => '\\StructType\\GetAvailableCreditByReferenceRequestData',
            'AvailableCreditResponse' => '\\StructType\\AvailableCreditResponse',
            'PostAccountTransactionRequest' => '\\StructType\\PostAccountTransactionRequest',
            'AccountTransactionMessage' => '\\StructType\\AccountTransactionMessage',
            'AccountBatch' => '\\StructType\\AccountBatch',
            'AccountTransactionBatch' => '\\StructType\\AccountTransactionBatch',
            'ModifiedMessage' => '\\StructType\\ModifiedMessage',
            'StateMessage' => '\\StructType\\StateMessage',
            'RequestBase' => '\\StructType\\RequestBase',
            'ResponseBaseOSI' => '\\StructType\\ResponseBaseOSI',
            'ResponseBase' => '\\StructType\\ResponseBase',
            'ArrayOfOtherServiceInformation' => '\\ArrayType\\ArrayOfOtherServiceInformation',
            'OtherServiceInformation' => '\\StructType\\OtherServiceInformation',
            'Voucher' => '\\StructType\\Voucher',
            'ArrayOfVoucherTransaction' => '\\ArrayType\\ArrayOfVoucherTransaction',
            'VoucherTransaction' => '\\StructType\\VoucherTransaction',
            'VoucherIssuanceBatchRequest' => '\\StructType\\VoucherIssuanceBatchRequest',
            'VoucherIssuance' => '\\StructType\\VoucherIssuance',
            'ArrayOfVoucher' => '\\ArrayType\\ArrayOfVoucher',
            'APIFault' => '\\StructType\\APIFault',
            'APIGeneralFault' => '\\StructType\\APIGeneralFault',
            'APICriticalFault' => '\\StructType\\APICriticalFault',
            'APIWarningFault' => '\\StructType\\APIWarningFault',
            'APIValidationFault' => '\\StructType\\APIValidationFault',
            'APISecurityFault' => '\\StructType\\APISecurityFault',
            'APIUnhandledServerFault' => '\\StructType\\APIUnhandledServerFault',
            'ArrayOfValidationResult' => '\\ArrayType\\ArrayOfValidationResult',
            'ValidationResult' => '\\StructType\\ValidationResult',
            'SerializableDictionaryOfstringstring' => '\\StructType\\SerializableDictionaryOfstringstring',
        );
    }
}
