<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for AccountTransactionType EnumType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AccountTransactionType
 * @subpackage Enumerations
 */
class AccountTransactionType extends AbstractStructEnumBase
{
    /**
     * Constant for value 'Default'
     * @return string 'Default'
     */
    const VALUE_DEFAULT = 'Default';
    /**
     * Constant for value 'PPAccountDebitForPayment'
     * @return string 'PPAccountDebitForPayment'
     */
    const VALUE_PPACCOUNT_DEBIT_FOR_PAYMENT = 'PPAccountDebitForPayment';
    /**
     * Constant for value 'PPAccountCredit'
     * @return string 'PPAccountCredit'
     */
    const VALUE_PPACCOUNT_CREDIT = 'PPAccountCredit';
    /**
     * Constant for value 'CreditAccountDebitForPayment'
     * @return string 'CreditAccountDebitForPayment'
     */
    const VALUE_CREDIT_ACCOUNT_DEBIT_FOR_PAYMENT = 'CreditAccountDebitForPayment';
    /**
     * Constant for value 'CreditAccountLimitAdjustment'
     * @return string 'CreditAccountLimitAdjustment'
     */
    const VALUE_CREDIT_ACCOUNT_LIMIT_ADJUSTMENT = 'CreditAccountLimitAdjustment';
    /**
     * Constant for value 'CreditAccountPayment'
     * @return string 'CreditAccountPayment'
     */
    const VALUE_CREDIT_ACCOUNT_PAYMENT = 'CreditAccountPayment';
    /**
     * Constant for value 'CreditAccountCredit'
     * @return string 'CreditAccountCredit'
     */
    const VALUE_CREDIT_ACCOUNT_CREDIT = 'CreditAccountCredit';
    /**
     * Constant for value 'CreditAccountSpoilage'
     * @return string 'CreditAccountSpoilage'
     */
    const VALUE_CREDIT_ACCOUNT_SPOILAGE = 'CreditAccountSpoilage';
    /**
     * Constant for value 'CreditNetCommission'
     * @return string 'CreditNetCommission'
     */
    const VALUE_CREDIT_NET_COMMISSION = 'CreditNetCommission';
    /**
     * Constant for value 'PayableCommissionAmount'
     * @return string 'PayableCommissionAmount'
     */
    const VALUE_PAYABLE_COMMISSION_AMOUNT = 'PayableCommissionAmount';
    /**
     * Constant for value 'StatementDateAndBalance'
     * @return string 'StatementDateAndBalance'
     */
    const VALUE_STATEMENT_DATE_AND_BALANCE = 'StatementDateAndBalance';
    /**
     * Constant for value 'ParentTransfer'
     * @return string 'ParentTransfer'
     */
    const VALUE_PARENT_TRANSFER = 'ParentTransfer';
    /**
     * Constant for value 'ChildTransfer'
     * @return string 'ChildTransfer'
     */
    const VALUE_CHILD_TRANSFER = 'ChildTransfer';
    /**
     * Constant for value 'ChildCredit'
     * @return string 'ChildCredit'
     */
    const VALUE_CHILD_CREDIT = 'ChildCredit';
    /**
     * Constant for value 'ChildDebit'
     * @return string 'ChildDebit'
     */
    const VALUE_CHILD_DEBIT = 'ChildDebit';
    /**
     * Constant for value 'ChildNetCommissionTransfer'
     * @return string 'ChildNetCommissionTransfer'
     */
    const VALUE_CHILD_NET_COMMISSION_TRANSFER = 'ChildNetCommissionTransfer';
    /**
     * Constant for value 'ParentNetCommissionTransfer'
     * @return string 'ParentNetCommissionTransfer'
     */
    const VALUE_PARENT_NET_COMMISSION_TRANSFER = 'ParentNetCommissionTransfer';
    /**
     * Constant for value 'SupplementaryAccountDebit'
     * @return string 'SupplementaryAccountDebit'
     */
    const VALUE_SUPPLEMENTARY_ACCOUNT_DEBIT = 'SupplementaryAccountDebit';
    /**
     * Constant for value 'SupplementaryAccountCredit'
     * @return string 'SupplementaryAccountCredit'
     */
    const VALUE_SUPPLEMENTARY_ACCOUNT_CREDIT = 'SupplementaryAccountCredit';
    /**
     * Constant for value 'Unmapped'
     * @return string 'Unmapped'
     */
    const VALUE_UNMAPPED = 'Unmapped';
    /**
     * Return allowed values
     * @uses self::VALUE_DEFAULT
     * @uses self::VALUE_PPACCOUNT_DEBIT_FOR_PAYMENT
     * @uses self::VALUE_PPACCOUNT_CREDIT
     * @uses self::VALUE_CREDIT_ACCOUNT_DEBIT_FOR_PAYMENT
     * @uses self::VALUE_CREDIT_ACCOUNT_LIMIT_ADJUSTMENT
     * @uses self::VALUE_CREDIT_ACCOUNT_PAYMENT
     * @uses self::VALUE_CREDIT_ACCOUNT_CREDIT
     * @uses self::VALUE_CREDIT_ACCOUNT_SPOILAGE
     * @uses self::VALUE_CREDIT_NET_COMMISSION
     * @uses self::VALUE_PAYABLE_COMMISSION_AMOUNT
     * @uses self::VALUE_STATEMENT_DATE_AND_BALANCE
     * @uses self::VALUE_PARENT_TRANSFER
     * @uses self::VALUE_CHILD_TRANSFER
     * @uses self::VALUE_CHILD_CREDIT
     * @uses self::VALUE_CHILD_DEBIT
     * @uses self::VALUE_CHILD_NET_COMMISSION_TRANSFER
     * @uses self::VALUE_PARENT_NET_COMMISSION_TRANSFER
     * @uses self::VALUE_SUPPLEMENTARY_ACCOUNT_DEBIT
     * @uses self::VALUE_SUPPLEMENTARY_ACCOUNT_CREDIT
     * @uses self::VALUE_UNMAPPED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DEFAULT,
            self::VALUE_PPACCOUNT_DEBIT_FOR_PAYMENT,
            self::VALUE_PPACCOUNT_CREDIT,
            self::VALUE_CREDIT_ACCOUNT_DEBIT_FOR_PAYMENT,
            self::VALUE_CREDIT_ACCOUNT_LIMIT_ADJUSTMENT,
            self::VALUE_CREDIT_ACCOUNT_PAYMENT,
            self::VALUE_CREDIT_ACCOUNT_CREDIT,
            self::VALUE_CREDIT_ACCOUNT_SPOILAGE,
            self::VALUE_CREDIT_NET_COMMISSION,
            self::VALUE_PAYABLE_COMMISSION_AMOUNT,
            self::VALUE_STATEMENT_DATE_AND_BALANCE,
            self::VALUE_PARENT_TRANSFER,
            self::VALUE_CHILD_TRANSFER,
            self::VALUE_CHILD_CREDIT,
            self::VALUE_CHILD_DEBIT,
            self::VALUE_CHILD_NET_COMMISSION_TRANSFER,
            self::VALUE_PARENT_NET_COMMISSION_TRANSFER,
            self::VALUE_SUPPLEMENTARY_ACCOUNT_DEBIT,
            self::VALUE_SUPPLEMENTARY_ACCOUNT_CREDIT,
            self::VALUE_UNMAPPED,
        );
    }
}
