<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for APIValidationFault StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:APIValidationFault
 * @subpackage Structs
 */
class APIValidationFault extends APIFault
{
    /**
     * The ValidationResults
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfValidationResult
     */
    public $ValidationResults;
    /**
     * Constructor method for APIValidationFault
     * @uses APIValidationFault::setValidationResults()
     * @param \ArrayType\ArrayOfValidationResult $validationResults
     */
    public function __construct(\ArrayType\ArrayOfValidationResult $validationResults = null)
    {
        $this
            ->setValidationResults($validationResults);
    }
    /**
     * Get ValidationResults value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfValidationResult|null
     */
    public function getValidationResults()
    {
        return isset($this->ValidationResults) ? $this->ValidationResults : null;
    }
    /**
     * Set ValidationResults value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfValidationResult $validationResults
     * @return \StructType\APIValidationFault
     */
    public function setValidationResults(\ArrayType\ArrayOfValidationResult $validationResults = null)
    {
        if (is_null($validationResults) || (is_array($validationResults) && empty($validationResults))) {
            unset($this->ValidationResults);
        } else {
            $this->ValidationResults = $validationResults;
        }
        return $this;
    }
}
