<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccountTransactionMessage StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AccountTransactionMessage
 * @subpackage Structs
 */
class AccountTransactionMessage extends AbstractStructBase
{
    /**
     * The TransactionState
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $TransactionState;
    /**
     * Constructor method for AccountTransactionMessage
     * @uses AccountTransactionMessage::setTransactionState()
     * @param string $transactionState
     */
    public function __construct($transactionState = null)
    {
        $this
            ->setTransactionState($transactionState);
    }
    /**
     * Get TransactionState value
     * @return string|null
     */
    public function getTransactionState()
    {
        return $this->TransactionState;
    }
    /**
     * Set TransactionState value
     * @uses \EnumType\MessageTransactionState::valueIsValid()
     * @uses \EnumType\MessageTransactionState::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $transactionState
     * @return \StructType\AccountTransactionMessage
     */
    public function setTransactionState($transactionState = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\MessageTransactionState::valueIsValid($transactionState)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\MessageTransactionState', is_array($transactionState) ? implode(', ', $transactionState) : var_export($transactionState, true), implode(', ', \EnumType\MessageTransactionState::getValidValues())), __LINE__);
        }
        $this->TransactionState = $transactionState;
        return $this;
    }
}
